﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Threading;

namespace ThreadEx1
{
    public partial class Form1 : Form
    {
        private Thread th;              // 쓰레드 생성
        private int i=0;                // 반복횟수 카운터용
        private Boolean start = false;  // 쓰레드 내부의 반복문 동작 플래그
        private float aa, bb;           // 백분율 연산을 위한 실수형 변수
        private string cc;              // 백분율 연산의 소숫점 자리 표현용 변수

        private int loop_count = 12000; // 초기 반복횟수 디폴트 값(수정 가능)

        public Form1()
        {
            InitializeComponent();
        }



        // ================================================================
        // AA()
        // 제작자 : haebi.kr
        // 제작일 : 2009. 09. 20
        // 내  용 : 서브 쓰레드 에서 작업될 내용이 기술됨
        // ================================================================
        private void AA()
        {
            while (start)
            {
                try
                {
                    i++;                    // 반복횟수 카운트
                    bb = i;                 // 실수 연산을 위한 실수형 변수에 정수값 대입
                    aa = (bb / loop_count); // 실수 연산 
                    aa = aa * 100;          // 실수 연산 윗 라인과 합해서 % 를 구함
                    
                    // 반복횟수 출력
                    this.label1.Text = "반복횟수 : " + Convert.ToString(i) + " / " + Convert.ToString(loop_count) ;

                    cc = string.Format("{0:F2}", aa);               // 소수점 2째 자리 까지 자름
                    this.label2.Text = "진행률 : " + cc + "%";      // 진행상황 백분율 표기
                    this.progressBar1.Value = i;                    // 진행바에 현재 진행상황을 표시

                    // 반복횟수가 처음 지정된 횟수에 도달하면...
                    if (i >= loop_count)
                    {
                        i = 0;                          // 0으로 횟수 초기화 시키고,
                        start = false;                  // 루프가 동작하지 않도록 while()문의 start에 false 지정
                        btnCtrl(true, false, false);    // 버튼 활성화, 비활성화 컨트롤
                        textBox1.Enabled = true;        // 반복횟수 재설정을 위한 텍스트 박스 활성화
                    }
                }
                catch { }
            }
        }



        // ================================================================
        // btnCtrl()
        // 제작자 : haebi.kr
        // 제작일 : 2009. 09. 20
        // 내  용 : 버튼 활성화 & 비활성화 제어 함수
        // ================================================================
        //
        // btn_start = button1
        // btn_pause = button2
        // btn_resume = button3

        private void btnCtrl(Boolean btn_start, Boolean btn_pause, Boolean btn_resume)
        {
            if (btn_start == false)
                button1.Enabled = false;
            else
                button1.Enabled = true;

            if (btn_pause == false)
                button2.Enabled = false;
            else
                button2.Enabled = true;

            if (btn_resume == false)
                button3.Enabled = false;
            else
                button3.Enabled = true;
        }



        // ================================================================
        // Form1_Load()
        // 제작자 : haebi.kr
        // 제작일 : 2009. 09. 20
        // 내  용 : 폼이 로드되면서 수행될 초기화 작업
        // ================================================================
        private void Form1_Load(object sender, EventArgs e)
        {
            progressBar1.Maximum = loop_count;              // 진행바의 최대 값 설정
            progressBar1.Minimum = 0;                       // 진행바의 최소 값 설정
            label1.Text = "반복횟수 : ";                    // 반복횟수 카운터 레이블 
            label2.Text = "진행률 : ";                      // 진행률 레이블
            textBox1.Text = Convert.ToString(loop_count);   // 반복횟수 입력 텍스트 상자(초기값은 미리 정의된 loop_count변수값 참조)
            
            btnCtrl(true, false, false);                    // 버튼 활성화 제어
        }



        // ================================================================
        // Form1_FormClosing()
        // 제작자 : haebi.kr
        // 제작일 : 2009. 09. 20
        // 내  용 : 폼이 종료되면서 수행될 초기화 작업
        // ================================================================
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            start = false;      // 쓰레드 내부 루프 중단

            if (!(th == null))  // 쓰레드가 null(비어있는 상태)이 아니면...
            {
                th.Abort();     // 쓰레드 종료    
            }
        }



        // ================================================================
        // button1_Click()
        // 제작자 : haebi.kr
        // 제작일 : 2009. 09. 20
        // 내  용 : Start ! 버튼 눌렀을때 실행
        // ================================================================
        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                loop_count = Convert.ToInt32(textBox1.Text);    // 텍스트 상자의 숫자를 읽어 loop_count 변수에 입력
                progressBar1.Maximum = loop_count;              // 진행바의 최대값에 loop_count 변수의 내용을 설정
                start = true;                                   // 쓰레드 내부 루프문동작 플래그
                th = new Thread(new ThreadStart(this.AA));      // 쓰레드 클래스의 새 인스턴스를 초기화
                th.Start();                                     // 쓰레드 실행
                btnCtrl(false, true, false);                    // 버튼 활성화 관련 제어
                textBox1.Enabled = false;                       // 텍스트 상자 비활성화
            }
            catch { }
        }



        // ================================================================
        // button2_Click()
        // 제작자 : haebi.kr
        // 제작일 : 2009. 09. 20
        // 내  용 : Pause 버튼 눌렀을때 실행
        // ================================================================
        private void button2_Click(object sender, EventArgs e)
        {
            try
            {
                btnCtrl(false, false, true);    // 버튼 활성화 제어
                start = false;
            }
            catch { }
        }



        // ================================================================
        // button3_Click()
        // 제작자 : haebi.kr
        // 제작일 : 2009. 09. 20
        // 내  용 : Resume 버튼 눌렀을때 실행
        // ================================================================
        private void button3_Click(object sender, EventArgs e)
        {
            try
            {
                btnCtrl(false, true, false);    // 버튼 활성화 제어
                start = true;
                th = new Thread(new ThreadStart(this.AA));      // 쓰레드 클래스의 새 인스턴스를 초기화
                th.Start();                                     // 쓰레드 실행
            }
            catch { }
        }



        // ================================================================
        // label3_Click()
        // 제작자 : haebi.kr
        // 제작일 : 2009. 09. 20
        // 내  용 : 하단의 라벨 클릭 시 제작자의 주소로 연결
        // ================================================================
        private void label3_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("IExplore", "http://haebi.kr");    // 익스플로러 실행, http://haebi.kr 로 연결!!
        }
    }
}